GZIP(1)

NAZWA
gzip, gunzip, zcat - kompresuje i dekompresuje pliki

SKŁADNIA
gzip [ -acdfhklLnNrtvV19 ] [-S rozszerzenie] [ nazwa ... ]
gunzip [ -acfhklLnNrtvV ] [-S\fP rozszerzenie] [ nazwa ... ]
zcat [ -fhLV ] [ nazwa ... ]

OPIS
The gzip command reduces the size of the named files using Lempel-Ziv coding (LZ77). Whenever possible, each file is replaced by one with the extension .gz, while keeping the same ownership modes, access and modification times. (The default extension is z for MSDOS, OS/2 FAT, Windows NT FAT and Atari.) If no files are specified, or if a file name is "-", the standard input is compressed to the standard output. The gzip command will only attempt to compress regular files. In particular, it will ignore symbolic links.

If the compressed file name is too long for its file system, gzip truncates it. The gzip command attempts to truncate only the parts of the file name longer than 3 characters. (A part is delimited by dots.) If the name consists of small parts only, the longest parts are truncated. For example, if file names are limited to 14 characters, gzip.msdos.exe is compressed to gzi.msd.exe.gz. Names are not truncated on systems which do not have a limit on file name length.

Domyślnie gzip zachowuje oryginalną nazwę pliku oraz czas modyfikacji i dostępu wewnątrz skompresowanego pliku. Jest ona używana podczas dekompresji z opcją -N. Jest to użytecznie, gdy nazwa skompresowanego pliku została obcięta lub czas modyfikacji nie został zachowany po transferze pliku.

Skompresowane pliki mogą być odtworzone do pierwotnej postaci przy użyciu poleceń gzip -d, gunzip lub zcat. Jeżeli oryginalna nazwa pliku zachowana wewnątrz pliku skompresowanego nie może być odtworzona w danym systemie plików, na podstawie oryginalnej nazwy tworzona jest nowa.

gunzip uruchamiany jest z listą plików w linii poleceń. Następnie każdy plik, którego nazwa kończy się rozszerzeniem .gz, -gz, .z, -z lub _z (wielkość znaków bez znaczenia) i w nagłówku pliku znajduje się prawidłowa liczba (magic number) jest dekompresowany i zastępowany oryginalnym plikiem bez jednego z powyższych rozszerzeń. gunzip rozpoznaje też specjalne rozszerzenia nazw plików .tgz i .taz jako skróty dla, odpowiednio, .tar.gz i .tar.Z. Podczas kompresji pliku z rozszerzeniem .tar, jeżeli jest to konieczne, gzip używa rozszerzenia .tgz zamiast obcinania nazwy pliku.

gunzip może dokonać dekompresji plików stworzonych przez programy gzip, zip, compress, compress -H lub pack. Format pliku wejściowego jest rozpoznawany automatycznie. Podczas dekompresji plików w pierwszych dwóch formatach gunzip sprawdza 32-bitową sumę kontrolną CRC. W wypadku plików stworzonych przez programy pack i gunzip sprawdzana jest długość zdekompresowanego pliku. Standardowy format programu compress nie umożliwiał kontroli poprawności. Jednak niekiedy gunzip jest w stanie wykryć uszkodzony plik .Z. Jeżeli w trakcie dekompresji takiego pliku pojawią się błędy, nie należy sądzić, że plik jest w porządku, bo program uncompress nie zgłaszał problemów. Oznacza to tylko, że uncompress nie kontroluje poprawności plików wejściowych. Format plików compress -H systemu SCO (kompresja metodą LZH) również nie obsługuje kontroli poprawności, lecz także możliwe jest podstawowe sprawdzenie spójności pliku.

Pliki stworzone przez program zip mogą być zdekompresowane tylko, jeżeli w archiwum .zip znajduje się jeden plik i jest on skompresowny metodą 'deflation'. Jest to opcja przeznaczona do konwersji plików .tar.zip do formatu .tar.gz. Aby zdekompresować plik .zip zawierający pojedynczy plik, można użyć poleceń gunzip < foo.zip czy gunzip -S .zip foo.zip.Do dekompresji archiwów .zip zawierających więcej niż jeden plik należy użyć programu unzip zamiast gunzip.

The zcat command is identical to gunzip -c. (On some systems, zcat may be installed as gzcat to preserve the original link to compress.) zcat uncompresses either a list of files on the command line or its standard input and writes the uncompressed data on standard output. zcat will uncompress files that have the correct magic number whether they have a .gz suffix or not.

The gzip command uses the Lempel-Ziv algorithm used in zip and PKZIP. The amount of compression obtained depends on the size of the input and the distribution of common substrings. Typically, text such as source code or English is reduced by 60-70%. Compression is generally much better than that achieved by LZW (as used in compress), Huffman coding (as used in pack), or adaptive Huffman coding (compact).

Kompresja jest przeprowadzana zawsze, nawet jeżeli plik wyjściowy jest większy niż oryginalny. W najgorszym przypadku narzut może wynosić kilka bajtów dla nagłówka i 5 bajtów dla każdego bloku o długości 32K. Ewentualnie współczynnik powiększenia pliku może wynosić 0,015% dla bardzo dużych plików. Należy zauważyć, że prawie nigdy nie zwiększa się liczba bloków używanych przez plik na dysku. gzip zachowuje tryb dostępu, właściciela pliku oraz czas dostępu i modyfikacji pliku podczas kompresji i dekompresji.

OPCJE

-a --ascii
    Tryb tekstowy. Przekształca znaki końca linii, używając lokalnych konwencji. Ta opcja jest dostępna jedynie na kilku systemach nieuniksowych. W systemie MS-DOS podczas kompresji znaki CR LF są przekształcane na LF, a podczas dekompresji z powrotem.

-c --stdout --to-stdout
    Wypisuje skompresowane dane na standardowe wyjście; oryginalne pliki pozostają nienaruszone. Jeżeli podanych zostało kilka plików wejściowych, każdy z nich kompresowany jest oddzielnie. Dla osiągnięcia lepszej kompresji należy połączyć pliki ze sobą przed poddaniem ich kompresji.

-d --decompress --uncompress
    Dekompresuje plik.

-f --force
    Kompresuje plik nawet, jeżeli istnieją do niego twarde dowiązania lub plik wyjściowy już istnieje, lub też, jeżeli dane są uprzednio skompresowane. Jeżeli format danych wejściowych nie jest rozpoznany, a podana została opcja --stdout, dane zostają bez zmian przekopiowane na standardowe wyjście. zcat zachowuje się w takim wypadku jak cat. Jeżeli opcja -f nie została podana i program został uruchomiony w pierwszym planie, gzip pyta użytkownika przed nadpisaniem istniejącego pliku.

-h --help
    Wyświetla ekran pomocy i kończy działanie.

-k --keep
    Zachowuje (nie usuwa) pliki wejściowe przy kompresji lub dekompresji.

-l --list
    Dla każdego skompresowanego pliku wypisuje następujące informacje:
      compressed size: rozmiar skompresowanego pliku
      uncompressed size: rozmiar zdekompresowanego pliku
      ratio: współczynnik kompresji (0.0% jeżeli nieznany)
      uncompressed_name: nazwa zdekompresowanego pliku Rozmiar zdekompresowanego pliku jest wypisywany jako -1 dla plików nie będących w formacie gzip, jak na przykład pliki .Z. Aby poznać rozmiar takiego pliku po dekompresji, można użyć polecenia:
      zcat file.Z | wc -c Po podaniu również opcji --verbose dodatkowo są wyświetlane następujące informacje:
      method: metoda kompresji
      crc: 32-bitowa suma kontrolna CRC zdekompresowanych danych
      date & time: pole daty/czasu oryginalnego pliku Aktualnie dostępne metody kompresji to deflate, compress, lzh (SCO compress -H) oraz pack. Suma CRC dla plików w formacie innym niż gzip jest podawana jako ffffffff. Po podaniu opcji --name podawane są dane oryginalnego pliku zawarte w pliku skompresowanym (nazwa, data/czas), jeżeli zostaną tam znalezione. Po podaniu opcji --verbose wyświetlany jest wspólny rozmiar i współczynnik kompresji wszystkich plików, chyba że nie dla wszystkich plików te dane są dostępne. Po podaniu opcji --quiet linie nagłówka i podsumowania nie są wyświetlane.

-L --license
    Wyświetla informację o licencji i kończy działanie programu.

-n --no-name
    Podczas kompresji nie zachowuje w skompresowanym pliku oryginalnej nazwy, trybu dostępu oraz czasu modyfikacji i dostępu. (Oryginalna nazwa jest zapisywana, jeżeli nazwa pliku będzie musiała być obcięta). Podczas dekompresji nie odtwarza oryginalnej nazwy pliku (usuwa tylko rozszerzenie.gz z nazwy pliku), nie odtwarza również oryginalnego pola daty/czasu - zamiast tego pole to zostanie skopiowane ze skompresowanego pliku. Jest to domyślna opcja podczas dekompresji.

-N --name
    Podczas kompresji zawsze zachowuje oryginalne pole daty/czasu; jest to zachowanie domyślne. Podczas dekompresji odtwarza oryginalne pole daty/czasu oraz nazwę pliku. Ta opcja jest użyteczna na sytemach z limitem długości nazwy pliku lub po utracie oryginalnego pola daty/czasu po transferze pliku.

-q --quiet
    Nie wyświetla żadnych ostrzeżeń.

-r --recursive
    Przechodzi rekurencyjnie zawartość katalogów. Jeśli którakolwiek z nazw plików podanych w lini poleceń odnosi się do katalogu, gzip przejdzie do tego katalogu i skompresuje wszystkie pliki, które w nim znajdzie (lub zdekompresuje w wypadku programu gunzip).

-S .suf --suffix .suf
    Przy kompresowaniu używa rozszerzenia .suf zamiast .gz. Można użyć dowolnego niepustego rozszerzenia, chociaż należy unikać innych niż .z lub .gz, aby uniknąć zamieszania po transferze plików do innego systemu. Przy dekompresowaniu dodaje .suf na początku listy rozszerzeń do wypróbowania, przy tworzeniu nazwy pliku wyjściowego z nazwy pliku wejściowego.

--synchronous
    Use synchronous output. With this option, gzip is less likely to lose data during a system crash, but it can be considerably slower.

-t --test
    Test. Check the compressed file integrity then quit.

-v --verbose
    Wyświetla nazwę i procent kompresji każdego skompresowanego i nieskompresowanego pliku.

-V --version
    Wyświetla numer wersji oraz opcje kompilacji i kończy działanie.

-# --fast --best
    Określa prędkość kompresji za pomocą cyfry #, gdzie -1 lub --fast oznacza najszybszą (lecz najmniej wydajną) kompresję, zaś -9 lub --best oznacza najwolniejszą (lecz najbardziej wydajną) metodę kompresji. Domyślną wartością jest -6 (tzn. zorientowaną na lepszą kompresję kosztem prędkości).

--rsyncable
    When you synchronize a compressed file between two computers, this option allows rsync to transfer only files that were changed in the archive instead of the entire archive. Normally, after a change is made to any file in the archive, the compression algorithm can generate a new version of the archive that does not match the previous version of the archive. In this case, rsync transfers the entire new version of the archive to the remote computer. With this option, rsync can transfer only the changed files as well as a small amount of metadata that is required to update the archive structure in the area that was changed.

ZAAWANSOWANE SPOSOBY UŻYCIA
Skompresowane pliki mogą być ze sobą łączone; w takim wypadku gunzip zdekompresuje wszystkie pliki jednocześnie. Na przykład:
      gzip -c plik1 > foo.gz
      gzip -c plik2 >> foo.gz Następnie
      gunzip -c foo jest równoznaczne z
      cat plik1 plik2 W wypadku, gdy jeden z połączonych plików zostanie uszkodzony, pozostałe wciąż mogą być odzyskane (po usunięciu uszkodzonego pliku). Jednak znacznie lepsze efekty daje jednoczesne kompresowanie wszystkich plików:
      cat plik1 plik2 | gzip > foo.gz daje lepsze wyniki kompresji niż
      gzip -c plik1 plik2 > foo.gz Aby ponownie skompresować połączone ze sobą pliki w celu uzyskania lepszej kompresji, należy wykonać polecenie:
      gzip -cd stary.gz | gzip > nowy.gz Jeżeli skompresowny plik został utworzony z kilku plików, informacje o rozmiarze i sumie CRC uzyskane opcją --list dotyczą tylko ostatniego pliku. Informację orozmiarze wszystkich plików po dekompresji można uzyskać przy pomocy polecenia:
      gzip -cd plik.gz | wc -c Jeżeli chcesz umieścić w archiwum kilka plików, a następnie mieć możliwość oddzielnego ich odzyskania, użyj programów takich jak tar lub zip. Tar w wersji GNU obsługuje opcję -z, która powoduje wywołanie programu gzip w sposób niewidzialny dla użytkownika. Gzip został zaprojektowany jako uzupełnienie programu tar; nie może go zastąpić.

ŚRODOWISKO
The obsolescent environment variable GZIP can hold a set of default options for gzip. These options are interpreted first and can be overwritten by explicit command line parameters. As this can cause problems when using scripts, this feature is supported only for options that are reasonably likely to not cause too much harm, and gzip warns if it is used. This feature will be removed in a future release of gzip.

You can use an alias or script instead. For example, if gzip is in the directory /usr/bin you can prepend $HOME/bin to your PATH and create an executable script $HOME/bin/gzip containing the following:
      #! /bin/sh
      export PATH=/usr/bin
      exec gzip -9 "$@"

ZOBACZ TAKŻE
znew(1), zcmp(1), zmore(1), zforce(1), gzexe(1), zip(1), unzip(1), compress(1)

Format pliku gzip jest opisany w: P. Deutsch, GZIP file format specification version 4.3, <https://www.ietf.org/rfc/rfc1952.txt>, Internet RFC 1952 (maj 1996). Format deflacji zipjest opisany w: P. Deutsch, DEFLATE Compressed Data Format Specification version 1.3, <https://www.ietf.org/rfc/rfc1951.txt>, Internet RFC 1951 (maj 1996).

DIAGNOSTYKA
Kod wyjścia jest normalnie równy 0; jeżeli wystapi błąd, kod wyjścia jest równy 1. Jeżeli wystąpi ostrzeżenie, kod wyjścia jest równy 2.

Usage: gzip [-cdfhklLnNrtvV19] [-S suffix] [file ...]
    W linii poleceń znalazły się nieprawidłowe opcje.

file: not in gzip format
    Podany plik nie jest skompresowany (komunikat programu gunzip).

file: Corrupt input. Use zcat to recover some data.
    Skompresowany plik uległ uszkodzeniu. Do miejsca uszkodzenia dane mogą być odzyskane poleceniem
        zcat file > recover

file: compressed with xx bits, can only handle yy bits
    Plik został skompresowany (z użyciem algorytmu LZW) przez program obsługujący kody o większej ilości bitów niż program do dekompresji na tym komputerze. Należy skompresować plik od nowa programem gzip, który osiąga lepszy współczynnik kompresji i używa mniej pamięci.

file: already has .gz suffix -- no change
    Plik z rozszerzeniem nazwy .gz nie może być ponownie kompresowany. Zmień nazwę pliku i spróbuj ponownie.

file already exists; do you wish to overwrite (y or n)?
    Należy odpowiedzieć "y", by nadpisać istniejący już plik wyjściowy lub "n" w przeciwnym przypadku.

gunzip: corrupt input
    Program otrzymał sygnał SIGSEGV, co zazwyczaj oznacza, że plik wejściowy jest uszkodzony.

xx.x% Osiągnięty stopień kompresji.
    (Tylko po podaniu opcji -v i -l).

-- not a regular file or directory: ignored
    Gdy plik wejściowy nie jest zwykłym plikiem lub katalogiem (tzn. jest np. dowiązaniem symbolicznym, gniazdem, kolejką FIFO, plikiem urządzenia), jest pozostawiany bez zmian.

-- has xx other links: unchanged
    Plik wejściowy ma twarde dowiązania i nie może zostać zmieniony. Więcej informacji można znaleźć w opisie polecenia ln(1). Użycie opcji -fwymusi kompresję plików mających twarde dowiązania.

OSTRZEŻENIA
When writing compressed data to a tape, it is generally necessary to pad the output with zeroes up to a block boundary. When the data is read and the whole block is passed to gunzip for decompression, gunzip detects that there is extra trailing garbage after the compressed data and emits a warning by default. You can use the --quiet option to suppress the warning.

BŁĘDY
Format gzip reprezentuje rozmiar wejścia modulo 2^32, a więc opcja --list zwraca niepoprawne rozmiary i współczynniki kompresji dla nieskompresowanych plików o rozmiarze 4 GB i większych. Aby obejść ten problem i poznać prawdziwy rozmiar dużego nieskompresowanego pliku, można wydać następujące polecenie:
  zcat file.Z | wc -c Opcja --list wypisuje rozmiar jako -1 i CRC jako ffffffff, jeżeli plik znajduje się na nośniku o dostępie sekwencyjnym. Niekiedy (rzadko) zdarza się, że kompresja z opcją --best daje gorsze rezultaty niż z opcją domyślną (-6). Niektóre pliki, w których powtarza się bardzo dużo sekwencji, są lepiej kompresowane programem compress niż gzip.

ZGŁASZANIE BŁĘDÓW
Raporty o błędach można wysyłać do <bug-gzip@gnu.org>.
GNU gzip home page: <https://www.gnu.org/software/gzip/>
Ogólna pomoc dotycząca oprogramowania GNU: <https://www.gnu.org/gethelp/>

PRAWA AUTORSKIE
Copyright © 1998-1999, 2001-2002, 2012, 2015-2021 Free Software Foundation, Inc.
Copyright © 1992, 1993 Jean-loup Gailly

Permission is granted to make and distribute verbatim copies of this manual provided the copyright notice and this permission notice are preserved on all copies.

Permission is granted to copy and distribute modified versions of this manual under the conditions for verbatim copying, provided that the entire resulting derived work is distributed under the terms of a permission notice identical to this one.

Permission is granted to copy and distribute translations of this manual into another language, under the above conditions for modified versions, except that this permission notice may be stated in a translation approved by the Foundation.

TŁUMACZENIE
Autorami polskiego tłumaczenia niniejszej strony podręcznika są: Łukasz Kowalczyk <lukow@tempac.okwf.fuw.edu.pl>, Michał Górny <zrchos+manpagespl@gmail.com> i Michał Kułach <michal.kulach@gmail.com> Niniejsze tłumaczenie jest wolną dokumentacją. Bliższe informacje o warunkach licencji można uzyskać zapoznając się z GNU General Public License w wersji 3 (https://www.gnu.org/licenses/gpl-3.0.html) lub nowszej. Nie przyjmuje się ŻADNEJ ODPOWIEDZIALNOŚCI. Błędy w tłumaczeniu strony podręcznika prosimy zgłaszać na adres manpages-pl-list@lists.sourceforge.net.